--[[/* MODULE */]]

local utils =
{
	api   = require 'libmodal/src/utils/api',
	classes = require 'libmodal/src/utils/classes',
	Indicator = require 'libmodal/src/utils/Indicator',
	Help = require 'libmodal/src/utils/Help',
	Popup = require 'libmodal/src/utils/Popup',
	Vars  = require 'libmodal/src/utils/Vars',
}

--- Show an error from `pcall()`.
--- @param pcall_err string the error generated by `pcall()`.
function utils.show_error(pcall_err)
	utils.api.nvim_bell()

	utils.api.nvim_show_err(
		require('libmodal/src/globals').DEFAULT_ERROR_TITLE,
		vim.v.throwpoint..'\n'..vim.v.exception..'\n'..pcall_err
	)
end

return utils
